from socket import AF_INET, socket, SOCK_STREAM
from threading import Thread
import tkinter
import random
characters_in_order = [chr(x) for x in range(32,127)]


def receive():
    """Handles receiving of messages."""
    while True:
        try:

            results = ''
            messages = ''

            messages = client_socket.recv(BUFSIZ).decode("utf8")

            random.seed(r_seed)
            shuffled_list = [chr(x) for x in range(32,127)]
            random.shuffle(shuffled_list)

            for i in range(0, len(messages)):
               results += characters_in_order[shuffled_list.index(messages[i])]

            msg_list.insert(tkinter.END, (results ))

            results = ''


        except OSError:  # Possibly client has left the chat.
            break


def send(event=None):  # event is passed by binders.
    """Handles sending of messages."""
    msg = my_msg.get()
    my_msg.set("")  # Clears input field.
    
    result = ''

    message = msg


    random.seed(r_seed)
    shuffled_list = [chr(x) for x in range(32,127)]
    random.shuffle(shuffled_list)

    for i in range(0, len(message)):
       result += shuffled_list[characters_in_order.index(message[i])]

    client_socket.send(bytes(result , "utf8"))
    result = ''
    if msg == "{quit}":
        client_socket.close()
        top.quit()


def on_closing(event=None):
    """This function is to be called when the window is closed."""
    my_msg.set("{quit}")
    send()

top = tkinter.Tk()
top.title("Chat")

messages_frame = tkinter.Frame(top)
my_msg = tkinter.StringVar()  # For the messages to be sent.
my_msg.set("Type your messages here.")
scrollbar = tkinter.Scrollbar(messages_frame)  # To navigate through past messages.
# Following will contain the messages.
msg_list = tkinter.Listbox(messages_frame, height=50, width=150, yscrollcommand=scrollbar.set)
scrollbar.pack(side=tkinter.RIGHT, fill=tkinter.Y)
msg_list.pack(side=tkinter.LEFT, fill=tkinter.BOTH)
msg_list.pack()
messages_frame.pack()

entry_field = tkinter.Entry(top, textvariable=my_msg)
entry_field.bind("<Return>", send)
entry_field.pack()
send_button = tkinter.Button(top, text="Send", command=send)
send_button.pack()

top.protocol("WM_DELETE_WINDOW", on_closing)

#----Now comes the sockets part----
HOST = input('Enter host: ')
PORT = input('Enter port: ')
r_seed = input('Enter Encryption code: ')
if not PORT:
    PORT = 33000
else:
    PORT = int(PORT)

BUFSIZ = 1024
ADDR = (HOST, PORT)

client_socket = socket(AF_INET, SOCK_STREAM)
client_socket.connect(ADDR)

receive_thread = Thread(target=receive)
receive_thread.start()
tkinter.mainloop()  # Starts GUI execution.